package org.htl.leonding.digitalsignage.wayfinder.entities;

import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;
import org.neo4j.ogm.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Cristopher on 30/12/2015.
 */
@NodeEntity
public class Floor {

    @Expose
    @GraphId
    private Long floorId;

    @Expose
    @Property
    private String name = "";

    @Expose
    @Property
    private String shortName = "";

    @SerializedName("picture")
    @Transient
    @Expose
    private String backgroundBase64URL = "";

    @Expose
    @Relationship(type = "HAS_NODE",direction = Relationship.OUTGOING)
    private List<MapNode> nodes = new ArrayList<MapNode>();

    @Expose
    @Property(name = "floorPlan")
    private String floorImageExternalForm = "";

    @Property(name="width")
    private double floorWidth;

    @Property(name="height")
    private double floorHeight;

    public double getFloorWidth() {
        return floorWidth;
    }

    public void setFloorWidth(double floorWidth) {
        this.floorWidth = floorWidth;
        nodes.forEach(MapNode::notifyObservers);
    }

    public double getFloorHeight() {
        return floorHeight;
    }

    public void setFloorHeight(double floorHeight) {
        this.floorHeight = floorHeight;
        nodes.forEach(MapNode::notifyObservers);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getFloorImageExternalForm() {
        return floorImageExternalForm;
    }

    public void setFloorImageExternalForm(String floorImageExternalForm) {
        this.floorImageExternalForm = floorImageExternalForm;
    }

    public List<MapNode> getNodes() {
        return nodes;
    }

    public void setNodes(List<MapNode> nodes) {
        this.nodes = nodes;
    }

    public long getFloorId() {
        return floorId;
    }

    public void setFloorId(Long floorId) {
        this.floorId = floorId;
    }

    public String getShortName() {
        return shortName;
    }

    public void setShortName(String shortName) {
        this.shortName = shortName;
    }

    public String getBackgroundBase64URL() {
        return backgroundBase64URL;
    }

    public void setBackgroundBase64URL(String backgroundBase64URL) {
        this.backgroundBase64URL = backgroundBase64URL;
    }

    public Floor() {
    }

    @Override
    public String toString() {
        return name + " [" + shortName + "]";
    }
}
