package org.htl.leonding.digitalsignage.wayfinder.entities;

import com.fasterxml.jackson.databind.annotation.JsonAppend;
import com.google.gson.annotations.Expose;
import javafx.scene.paint.Color;
import org.htl.leonding.digitalsignage.wayfinder.interfaces.IDoForThisSubtype;
import org.htl.leonding.digitalsignage.wayfinder.models.MapNodeType;
import org.htl.leonding.digitalsignage.wayfinder.views.baseeditor.BaseEditorPresenter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

/**
 * Created by Cristopher on 08/12/2015.
 */
public class Lift extends MapNode implements IDoForThisSubtype {

    @Relationship(type = "LIFT_ABOVE")
    private Lift liftAbove;

    @Relationship(type = "LIFT_BELOW")
    private Lift liftBelow;


    public Lift(double radius){
        super(Color.GREEN,radius);
        this.setName("NO NAME");
        isA = MapNodeType.Lift.name();
    }

    public Lift(){
        super(Color.GREEN,DEFAULT_RADIUS);
        isA = MapNodeType.Lift.name();
    }


    public Lift getLiftAbove() {
        return liftAbove;
    }

    public void setLiftAbove(Lift liftAbove) {
        this.liftAbove = liftAbove;
    }

    public Lift getLiftBelow() {
        return liftBelow;
    }

    public void setLiftBelow(Lift liftBelow) {
        this.liftBelow = liftBelow;
    }

    @Override
    public void setPropertyForThisClass(BaseEditorPresenter controller) {
        controller.changeToLiftProperty();
    }


    @Override
    public String toString(){
        return getName();
    }
}
