package org.htl.leonding.digitalsignage.wayfinder.entities;

import javafx.scene.paint.Color;
import org.htl.leonding.digitalsignage.wayfinder.interfaces.IDoForThisSubtype;
import org.htl.leonding.digitalsignage.wayfinder.models.MapNodeType;
import org.htl.leonding.digitalsignage.wayfinder.views.baseeditor.BaseEditorPresenter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Relationship;

/**
 * Created by Cristopher on 08/12/2015.
 */
public class Stair extends MapNode implements IDoForThisSubtype {

    @Relationship(type = "STAIR_ABOVE")
    private Stair stairAbove;

    @Relationship(type = "STAIR_BELOW")
    private Stair stairBelow;

    public Stair getStairAbove() {
        return stairAbove;
    }

    public void setStairAbove(Stair stairAbove) {
        this.stairAbove = stairAbove;
    }

    public Stair getStairBelow() {
        return stairBelow;
    }

    public void setStairBelow(Stair stairBelow) {
        this.stairBelow = stairBelow;
    }

    public Stair(double radius) {
        super(Color.BROWN, radius);
        this.setName("NO NAME");
        isA = MapNodeType.Stair.name();
    }

    public Stair(){
        super(Color.BROWN,DEFAULT_RADIUS);
        isA = MapNodeType.Stair.name();
    }

    @Override
    public void setPropertyForThisClass(BaseEditorPresenter controller) {
        controller.changeToStairProperty();
    }

    @Override
    public String toString() {
        return this.getName();
    }
}
