package org.htl.leonding.digitalsignage.wayfinder.repositories;

import org.htl.leonding.digitalsignage.wayfinder.entities.Floor;
import org.htl.leonding.digitalsignage.wayfinder.entities.MapNode;
import org.htl.leonding.digitalsignage.wayfinder.models.EditorModel;

import javax.inject.Inject;
import java.util.ArrayList;

/**
 * Created by Cristopher on 07/01/2016.
 */
public class RemoveFloorFromDbThread implements Runnable {

    @Inject
    EditorModel model;

    Floor deleteFloor;

    public RemoveFloorFromDbThread(Floor deleteFloor){
        this.deleteFloor = deleteFloor;
    }

    @Override
    public void run() {
        ArrayList<MapNode> mapNodeList = new ArrayList<>(deleteFloor.getNodes());
        DatabaseRepository.getInstance().getSession().beginTransaction();
        mapNodeList.forEach(n -> {
            n.getRelations().forEach(r -> DatabaseRepository.getInstance().getSession().delete(r));
            DatabaseRepository.getInstance().getSession().delete(n);
        });
        DatabaseRepository.getInstance().getSession().delete(deleteFloor);
        DatabaseRepository.getInstance().getSession().getTransaction().commit();
    }
}
