package org.htl.leonding.digitalsignage.wayfinder.serialization;

import com.google.gson.*;
import org.htl.leonding.digitalsignage.wayfinder.entities.ConnectRelation;
import org.neo4j.ogm.json.JSONArray;
import org.neo4j.ogm.json.JSONException;
import org.neo4j.ogm.json.JSONObject;

import java.lang.reflect.Type;

/**
 * Created by Cristopher on 07/03/2016.
 */
public class ConnectRelationSerializer implements JsonSerializer<ConnectRelation> {
    @Override
    public JsonElement serialize(ConnectRelation connectRelation, Type type, JsonSerializationContext jsonSerializationContext) {
        Gson gsonConnectRelation = new GsonBuilder().excludeFieldsWithoutExposeAnnotation().create();

        String connectRelationString = gsonConnectRelation.toJson(connectRelation);


        JSONObject jObject = new JSONObject();
        try {
            jObject = new JSONObject(connectRelationString);
        } catch (JSONException e) {
            e.printStackTrace();
        }

        try {
            JSONObject tempObject = new JSONObject();
            tempObject.put("nodeId", connectRelation.getStartNode().getNodeId());
            tempObject.put("isA",connectRelation.getStartNode().getIsA());

            jObject.put("startNodeId", tempObject);
        } catch (JSONException e) {
            e.printStackTrace();
        }

        try {
            JSONObject tempObject = new JSONObject();
            tempObject.put("nodeId", connectRelation.getEndNode().getNodeId());
            tempObject.put("isA",connectRelation.getEndNode().getIsA());

            jObject.put("endNodeId", tempObject);
        } catch (JSONException e) {
            e.printStackTrace();
        }

        return new JsonParser().parse(jObject.toString());

    }
}
