package org.htl.leonding.digitalsignage.wayfinder.serialization;

import com.google.gson.*;
import org.htl.leonding.digitalsignage.wayfinder.entities.*;
import org.htl.leonding.digitalsignage.wayfinder.entities.Room;
import org.neo4j.ogm.json.JSONException;
import org.neo4j.ogm.json.JSONObject;

import java.lang.reflect.Type;

/**
 * Created by Cristopher on 03/03/2016.
 */
public class MapNodeDeserializer implements JsonDeserializer<MapNode> {
    @Override
    public MapNode deserialize(JsonElement jsonElement,
                               Type type,
                               JsonDeserializationContext jsonDeserializationContext) throws JsonParseException {

        JSONObject jsonObject = null;
        try {
            jsonObject = new JSONObject(jsonElement.toString());
        } catch (JSONException e) {
            e.printStackTrace();
        }
        Gson gson = new GsonBuilder().excludeFieldsWithoutExposeAnnotation().create();
        try {
            switch (jsonObject.getString("isA")) {
                case "Room":
                    return gson.fromJson(jsonObject.toString(), Room.class);
                case "Corner":
                    return gson.fromJson(jsonObject.toString(), Corner.class);
                case "Lift":
                    return gson.fromJson(jsonObject.toString(), Lift.class);
                case "Stair":
                    return gson.fromJson(jsonObject.toString(), Stair.class);
                default:
                    return null;
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return null;
    }
}
