package org.htl.leonding.digitalsignage.wayfinder.views.cornereditor;

import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextField;
import org.htl.leonding.digitalsignage.wayfinder.entities.Corner;
import org.htl.leonding.digitalsignage.wayfinder.models.EditorModel;

import javax.inject.Inject;
import java.net.URL;
import java.util.Observable;
import java.util.Observer;
import java.util.ResourceBundle;

/**
 * Created by Cristopher on 03/01/2016.
 */
public class CornerEditorPresenter implements Initializable {

    @Inject
    EditorModel model;

    @FXML
    private TextField tfCorner;

    Corner corner;

    @Override
    public void initialize(URL location, ResourceBundle resources){
        corner = (Corner) model.getCurrentNode();
        System.out.println(corner);

        tfCorner.focusedProperty().addListener((observable, oldValue, newValue) -> {
            if (!newValue) {
                corner.setName(tfCorner.getText());
                model.updateNode(corner);
            }
        });

        updateUI();
    }


    private void updateUI(){
        tfCorner.setText(corner.getName());
    }
}
