package org.htl.leonding.digitalsignage.wayfinder.views.roomeditor;

import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextField;
import org.htl.leonding.digitalsignage.wayfinder.entities.Room;
import org.htl.leonding.digitalsignage.wayfinder.models.EditorModel;

import javax.inject.Inject;
import java.net.URL;
import java.util.ResourceBundle;

/**
 * Created by Cristopher on 03/01/2016.
 */
public class RoomEditorPresenter implements Initializable {

    @Inject
    EditorModel model;

    @FXML
    private TextField tfRoomName;

    Room currentRoom;

    @Override
    public void initialize(URL location, ResourceBundle resources) {
        currentRoom = (Room) model.getCurrentNode();
        System.out.println(currentRoom.getNodeId());

        tfRoomName.focusedProperty().addListener((observable, oldValue, newValue) -> {
            if (!newValue) {
                currentRoom.setName(tfRoomName.getText());
                model.updateNode(currentRoom);
            }/*else{
                tfRoomName.setText(currentRoom.getName());
            }*/
        });
        updateUI();
    }

    public void updateUI() {
        this.tfRoomName.setText(currentRoom.getName());
    }
}
